//****************************************************************************
//Copyright (C) 2005-2006 Beijing BlueDJ Technology Co.,Ltd. All rights reserved.

//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program (in the file LICENSE.GPL); if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

//Please visit http://www.bluedj.com for more infomation about us.
//Contact us at ggwizard@gmail.com or darkdong@gmail.com.
//****************************************************************************/

#ifndef	DJMATRIXCANVASSPRITE_H
#define DJMATRIXCANVASSPRITE_H

#include <Qt3Support>
#include "DJBaseGlobal.h"

class DJ_BASE_EXPORT DJMatrixCanvasSprite
{
public:
	DJMatrixCanvasSprite( Q3Canvas *canvas, const QString& filePath );
	virtual ~DJMatrixCanvasSprite();
	
	Qt::Alignment alignment() const { return m_alignment; }
	void setAlignment( Qt::Alignment align );
	void setInnerMatrix( const QMatrix& matrix );
	void setExternalMatrix( const QMatrix& matrix );
	double x() const;
	double y() const;
	int width() const;
	int height() const;
	int realWidth() const;
	int realHeight() const;
	void matrimove(  double x, double y );
	void move(  double x, double y );
	void setZ( double z );
	void show();
	void hide();
private:
	void initWithFile( const QString& filePath );
	
	Q3Canvas			*m_canvas;
	QString				m_filePath;
	Q3CanvasPixmapArray	*m_pixmaps;
	Q3CanvasSprite		*m_sprite;
	
	QMatrix				m_externalMatrix,m_innerMatrix;
	double				m_x,m_y;
	Qt::Alignment		m_alignment;
};
#endif
